<?php
/***********************************************************
	Filename: app/admin/control/addexpense.php
	Note	: 店铺管理
	Version : 3.0
	Author  : qinggan
	Update  : 2010-11-26
***********************************************************/
class addexpense_c extends Control
{
	function __construct()
	{
		parent::Control();
		$this->load_model("expense");
		$this->load_model("elder");
		$this->load_model("products");
		$this->load_model("shop");
		$this->load_model("admin");
	}

	function addexpense_c()
	{
		$this->__construct();
	}


	function index_f()
	{
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		$id = $this->trans_lib->int("id");
		sys_popedom("expense:add","tpl");//添加权限
		$this->tpl->display("expense/set_first.html");
	}

	function set_f()
	{
		$id = $this->trans_lib->int("id");
		$id ? sys_popedom("expense1:modify","tpl") : sys_popedom("expense1:add","tpl");
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$backurl = $_SERVER["HTTP_REFERER"] ? $_SERVER["HTTP_REFERER"] : ($id ? $this->url("expense_list") : $this->url("addexpense"));
		if($id)
		{
			$rs = $this->expense_m->get_one($id);
			if(!$rs)
			{
				error("操作非法！没有找到相关信息",$backurl);
			}
			//非系统管理员进行权限判断
			if(!$admin_rs["if_system"])
			{
				if($rs["admin_id"] != $_SESSION["admin_id"])
				{
					error("您没有权限操作此表单",$backurl);
				}
				//已审核信息禁止编辑
				if($rs["status"])
				{
					error("该条信息，超级管理员已经审核过，您没有权限更改",$backurl);
				}
			}
			$elder_rs = $this->elder_m->get_one($rs["elder_id"]);
			$this->tpl->assign("elder_rs",$elder_rs);
		}
		else
		{
			$exp_mth_no = $this->trans_lib->safe("exp_mth_no");
			$ret_mth_no = $this->trans_lib->safe("ret_mth_no");
			if(!$exp_mth_no || !$ret_mth_no)
			{
				error("杂费消费时间或房租交费时间为空",$backurl);
			}
			$elder = $this->trans_lib->safe("elder");
			if(!$elder)
			{
				error("老人编号不允许为空！",$backurl);
			}
			$elder_rs = $this->elder_m->get_one($elder,"num");
			if(!$elder_rs)
			{
				error("老人信息不存在！",$backurl);
			}
			if(!$elder_rs["status"])
			{
				error("老人信息未审核，不能执行此操作",$backurl);
			}
			/*
			if($elder_rs["lifestatus"] != "生存")
			{
				error("老人信息状态不是“生存”，不能执行此操作",$backurl);
			}*/
			$chk_exists = $this->expense_m->chk_exists($elder_rs["id"],$exp_mth_no,$ret_mth_no);
			if($chk_exists)
			{
				if($chk_exists["status"])
				{
					error("此老人 ".$exp_mth_no." 杂费信息（".$ret_mth_no." 租费信息）已经存在，请到列表中进行查看！",$backurl);
				}
				else
				{
					error("此老人数据已存在，正在跳转至编辑页面中，请稍候…",$this->url("addexpense,set","id=".$chk_exists["id"]));
				}
			}
			$this->tpl->assign("elder_rs",$elder_rs);
			$this->expense_m->clear_tmp_exp($_SESSION["admin_id"]);//清空统计
			$rs = array();
			$rs["exp_mth_no"] = $exp_mth_no;
			$rs["ret_mth_no"] = $ret_mth_no;
			$rs["elder_id"] = $elder_rs["id"];
			$rs["ret_charge"] = $elder_rs["rent"];
			$rs["exp_diapers"] = $elder_rs["diapers"];
			$rs['fixed_charges'] = $elder_rs['fixed_charges'];
		}

		$prolist = $this->products_m->get_all();//取得产品列表
		if($prolist)
		{
			if($id)
			{
				$sublist = $this->expense_m->get_expense_all($id,"pid");
				foreach($prolist AS $key=>$value)
				{
					$prolist[$key]["count"] = $sublist[$value["id"]]["qty"] ? $sublist[$value["id"]]["qty"] : 0;
				}
			}
			else
			{
				$total_price = 0;
				//[加载老人消费常用表]
				$sublist = $this->elder_m->expense_all($rs["elder_id"]);
				if($sublist)
				{
					foreach($prolist AS $key=>$value)
					{
						$prolist[$key]["count"] = 0;
						if($sublist[$value["id"]]["pronum"])
						{
							$prolist[$key]["count"] = $sublist[$value["id"]]["pronum"];
							$total_price += $value["price"] * $sublist[$value["id"]]["pronum"];
						}
					}
				}
				$rs["exp_charge"] = $total_price;
			}
			$this->tpl->assign("prolist",$prolist);
		}
		$this->tpl->assign("rs",$rs);
		$this->tpl->display("expense/set.html");
	}

	function ajax_show_f()
	{
		$num = $this->trans_lib->safe("num");
		$array = array();
		if(!$num)
		{
			$array["error"] = "请选择编号";
			exit($this->json_lib->encode($array));
		}
		$rs = $this->elder_m->get_one($num,"num");
		if(!$rs)
		{
			$array["error"] = "没有找到信息";
			exit($this->json_lib->encode($array));
		}
		$rs["fullname"] = $rs["cn_fullname"];
		$rs["error"] = "ok";
		$rs["rent"] = $rs["rent"]>0 ? sys_format_price($rs["rent"]) : "";
		exit($this->json_lib->encode($rs));
	}

	function setok_f()
	{
		$array = array();
		$id = $this->trans_lib->int("id");
		$backurl = $_SERVER["HTTP_REFERER"] ? $_SERVER["HTTP_REFERER"] : ($id ? $this->url("expense_list") : $this->url("addexpense"));
		$id ? sys_popedom("expense1:modify","tpl") : sys_popedom("expense1:add","tpl");
		if($id)
		{
			$rs = $this->expense_m->get_one($id);
			if(!$rs)
			{
				error("没有找到相关数据，请检查",$backurl);
			}
		}
		else
		{
			$array["exp_mth_no"] = $this->trans_lib->safe("exp_mth_no");
			$array["ret_mth_no"] = $this->trans_lib->safe("ret_mth_no");
		}
		//写总价
		$elder_id = $this->trans_lib->int("elder_id");
		if(!$elder_id)
		{
			error("没有指定租户",$backurl);
		}
		//检测该用户是否合法
		$elder_rs = $this->elder_m->get_one($elder_id);
		if(!$elder_rs)
		{
			error("没有找到相关租户信息",$backurl);
		}
		//检测管理员是否有此权限
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		if(!$admin_rs["if_system"])
		{
			$shop_rs = $this->shop_m->get_one_from_admin($_SESSION["admin_name"]);
			if(!$shop_rs)
			{
				error("该管理员无此操作权限",$backurl);
			}
			$shopid = $shop_rs["id"];
			if($elder_rs["shopid"] != $shopid)
			{
				error("您没有操作该租户的权限",$backurl);
			}
		}
		//
		$array["elder_id"] = $elder_id;
		//检查此条记录是否存在了
		$chk_exists = $this->expense_m->chk_exists($elder_id,$array["exp_mth_no"],$array["ret_mth_no"],$id);
		if($chk_exists)
		{
			error("该记录已经存在，请检查！",$backurl);
		}
		$array["exp_charge"] = $this->trans_lib->safe("exp_charge");
		$array["ret_charge"] = $this->trans_lib->safe("ret_charge");
		$array["exp_diapers"] = $this->trans_lib->safe("exp_diapers");
		$array["fixed_charges"] = $this->trans_lib->float("fixed_charges");
		if(!$id)
		{
			$array["addtime"] = $this->system_time;
			$array["status"] = 0;//设为未审核状态，需经超级管理进行审核后才能执行下一步
			$array["admin_id"] = $_SESSION["admin_id"];
		}
		$array["printcount"] = 0;//打印次数
		$insert_id = $this->expense_m->save($array,$id);
		if(!$id && !$insert_id)
		{
			error("数据存储失败，请检查！",$backurl);
		}
		//更新产详细数据
		$keys = array();
		if($id)
		{
			$sublist = $this->expense_m->get_expense_all($id,"pid");
			$keys = $sublist ? array_keys($sublist) : array();
		}
		$prolist = $this->products_m->get_all();
		$total_price = 0;
		
		foreach($prolist AS $key=>$value)
		{
			$count = $this->trans_lib->float("proid_count_".$value["id"]);
			if($count>0.001)
			{
				if($keys && count($keys)>0 && in_array($value["id"],$keys) && $sublist)
				{
					$tmp_array = array();
					$tmp_array["qty"] = $count;
					$this->expense_m->save_exp($tmp_array,$sublist[$value["id"]]["id"]);
					unset($tmp_array);
				}
				else
				{
					$tmp_array = array();
					$tmp_array["pid"] = $value["id"];
					$tmp_array["title"] = $value["title"];
					$tmp_array["qty"] = $count;
					$tmp_array["eid"] = $id ? $id : $insert_id;
					$tmp_array["price"] = $value["price"];
					$this->expense_m->save_exp($tmp_array);
				}
				$total_price += $count * $value["price"];
			}else{
				$tmp_eid = $id ? $id : $insert_id;
				$this->expense_m->del_exp($value['id'],$tmp_eid);
			}
		}
		//更新总价
		$goback = $this->trans_lib->safe("goback");
		if(!$goback)
		{
			$goback = $id ? $this->url("expense_list") : $this->url("addexpense");
		}
		if($id)
		{
			$_SESSION["highlight_id"] = $id;
			$total_array = array();
			$total_array["exp_charge"] = $total_price;
			$this->expense_m->save($total_array,$id);
			error("信息编辑成功！",$goback);
		}
		else
		{
			//$_SESSION["highlight_id"] = $insert_id;
			$total_array = array();
			$total_array["exp_charge"] = $total_price;
			$this->expense_m->save($total_array,$insert_id);
			error("数据添加成功！",$goback);
		}
	}

	function explist_f()
	{
		$id = $this->trans_lib->int("id");
		$rslist = $id ? $this->expense_m->get_expense_all($id) : $this->expense_m->get_tmp_all($_SESSION["admin_id"]);
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->display("expense/ajax_explist.html");
	}
}
?>