<?php
/**
 * 每日消费登记
 * @作者 苏相锟 <admin@phpok.com>
 * @主页 https://www.phpok.com
 * @版本 5.x
 * @授权 GNU Lesser General Public License https://www.phpok.com/lgpl.html 
 * @时间 2021年11月24日
**/

class day_c extends Control
{
	public function __construct()
	{
		parent::Control();
		$this->load_model("elder");
		$this->load_model("shop");
		$this->load_model("admin");
		$this->load_model("day");
		$this->load_model("products");
	}

	public function index_f()
	{
		$shoplist = $this->shop_m->get_all("status='1'");//取得所有分类
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$now = date("Y");
		$year_m = $now-10;
		$yearlist = array();
		for($i=$now;$i>$year_m;$i--){
			$yearlist[] = $i;
		}
		$this->tpl->assign('yearlist',$yearlist);
		$this->tpl->assign('monthlist',array('01','02','03','04','05','06','07','08','09','10','11','12'));
		$etime = $this->trans_lib->safe("etime");
		$condition = "1=1";
		$pageurl  = $this->url("day");
		if($etime){
			$condition = " d.expdate='".$etime."' ";
			$this->tpl->assign("etime",$etime);
			$pageurl .= "etime=".rawurlencode($etime)."&";
		}else{
			$year = $this->trans_lib->int('year');
			$month = $this->trans_lib->safe("month");
			if($year && $month){
				$condition = " d.expdate LIKE '".$year."-".$month."%' ";
				$this->tpl->assign("month",$month);
				$this->tpl->assign("year",$year);
				$pageurl .= "year=".rawurlencode(year)."&month=".$month;
			}
		}
		$shopid = $this->trans_lib->int("shopid");
		if(!$admin_rs["if_system"]){
			$tmp_shoplist = array();
			$tmp_shopid = array();
			foreach($shoplist as $key=>$value){
				if($value["admin_name"] && in_array($_SESSION["admin_name"],sys_id_list($value["admin_name"]))){
					$tmp_shoplist[] = $value;
					$tmp_shopid[] = $value["id"];
				}
			}
			if(count($tmp_shoplist)<1){
				error("该管理员没有相关分院权限");
			}
			$shoplist = $tmp_shoplist;
			unset($tmp_shoplist);
			if(!$shopid){
				$condition .= " AND e.shopid IN(".sys_id_string($tmp_shopid).") ";
			}
		}
		if($shopid){
			$condition .= " AND e.shopid='".$shopid."'";
			$pageurl .= "shopid=".$shopid."&";
			$this->tpl->assign('shopid',$shopid);
		}
		$this->tpl->assign("shoplist",$shoplist);
		$keytype = $this->trans_lib->safe("keytype");
		$keywords = $this->trans_lib->safe('keywords');
		if($keytype && $keywords){
			$condition .= " AND ".$keytype."='".$keywords."'";
			$pageurl .= "keytype=".$keytype."&keywords=".rawurlencode($keywords)."&";
			$this->tpl->assign('keytype',$keytype);
			$this->tpl->assign('keywords',$keywords);
		}
		$total = $this->day_m->get_count($condition);
		if($total){
			$pageid = $this->trans_lib->int(SYS_PAGEID);
			$psize = defined("SYS_PSIZE") ? SYS_PSIZE : 30;
			$rslist = $this->day_m->get_all($condition,$pageid,$psize);
			$this->tpl->assign('rslist',$rslist);
			$this->page_lib->set_psize($psize);
			$pagelist = $this->page_lib->page($pageurl,$total);
			if($pagelist){
				$this->tpl->assign("pagelist",$pagelist);
			}
		}
		
		//计算上个月是否锁定
		$this->tpl->display("day/index.html");
	}

	public function add_f()
	{
		$shoplist = $this->shop_m->get_all("status='1'");//取得所有分类
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		if(!$admin_rs["if_system"]){
			$tmp_shoplist = array();
			$tmp_shopid = array();
			foreach($shoplist as $key=>$value){
				if($value["admin_name"] && in_array($_SESSION["admin_name"],sys_id_list($value["admin_name"]))){
					$tmp_shoplist[] = $value;
					$tmp_shopid[] = $value["id"];
				}
			}
			if(count($tmp_shoplist)<1){
				error("该管理员没有相关分院权限");
			}
			$shoplist = $tmp_shoplist;
		}
		$this->tpl->assign("shoplist",$shoplist);
		$this->tpl->assign("shoplist",$shoplist);
		$this->tpl->assign('expdate',date("Y-m-d"));
		$total = $this->products_m->get_count(0,"");
		$rslist = $this->products_m->get_list(0,"",0,$total);//取得产品列表
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->display("day/set.html");
	}

	public function set_f()
	{
		$id = $this->trans_lib->int("id");
		if(!$id){
			error('未指定老人');
		}
		$rs = $this->elder_m->get_one($id);
		if(!$rs){
			error('老人不存在');
		}
		$this->tpl->assign('rs',$rs);
		$expdate = $this->trans_lib->safe("expdate");
		if(!$expdate){
			$expdate = date("Y-m-d");
		}
		$this->tpl->assign('expdate',$expdate);
		$shoplist = $this->shop_m->get_all("status='1'");//取得所有分类
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		if(!$admin_rs["if_system"]){
			$tmp_shoplist = array();
			$tmp_shopid = array();
			foreach($shoplist as $key=>$value){
				if($value["admin_name"] && in_array($_SESSION["admin_name"],sys_id_list($value["admin_name"]))){
					$tmp_shoplist[] = $value;
					$tmp_shopid[] = $value["id"];
				}
			}
			if(count($tmp_shoplist)<1){
				error("该管理员没有相关分院权限");
			}
			$shoplist = $tmp_shoplist;
		}
		$this->tpl->assign("shoplist",$shoplist);
		$expenselist = $this->day_m->get_list($id,$expdate);
		$this->tpl->assign('expenselist',$expenselist);
		$total = $this->products_m->get_count(0,"");
		$rslist = $this->products_m->get_list(0,"",0,$total);//取得产品列表
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->display("day/set.html");
	}

	public function setok_f()
	{
		$shopid = $this->trans_lib->int("shopid");
		$num = $this->trans_lib->safe("num");
		if(!$shopid){
			error("未指分院");
		}
		if(!$num){
			error("未指定编号");
		}
		$rs = $this->elder_m->chk_num($num,$shopid);
		if(!$rs){
			error('老人信息不存在');
		}
		$expdate = $this->trans_lib->safe("expdate");
		if(!$expdate){
			$expdate = date("Y-m-d");
		}
		//更新每日数据
		$expenselist = $this->day_m->get_list($rs['id'],$expdate);
		$total = $this->products_m->get_count(0,"");
		$rslist = $this->products_m->get_list(0,"",0,$total);//取得产品列表
		$keys = $expenselist ? array_keys($expenselist) : array();
		foreach($rslist as $key=>$value){
			$pronum = $this->trans_lib->float("proid_".$value["id"]);
			if($pronum>0.001){
				$data = array('elder_id'=>$rs['id'],'expdate'=>$expdate);
				$data['pid'] = $value['id'];
				$data['qty'] = $pronum;
				$this->day_m->save($data);
			}else{
				if($keys && count($keys)>0 && in_array($value["id"],$keys)){
					$this->day_m->del($rs['id'],$value["id"],$expdate);
				}
			}
		}
		//更新总数据
		$this->expense_month($rs['id'],$expdate,$rslist);
		$backurl = $this->url("day",'&shopid='.$shopid);
		error('数据保存成功，请稍候…',$backurl);
	}

	private function expense_month($eid,$expdate,$rslist)
	{
		$expenselist = $this->day_m->eAll($eid,$expdate);
		$keys = $expenselist ? array_keys($expenselist) : array();
		foreach($rslist as $key=>$value){
			if($expenselist[$value['id']]){
				$this->day_m->expense_save($value["id"],$eid,$expenselist[$value['id']],$expdate);
			}else{
				$this->day_m->expense_del($value["id"],$eid,$expdate);
			}
		}
	}

	private function expense_save($eid,$expdate,$rslist)
	{
		$expenselist = $this->day_m->eAll($eid,$expdate);
		$keys = $expenselist ? array_keys($expenselist) : array();
		foreach($rslist as $key=>$value){
			if($expenselist[$value['id']]){
				$this->elder_m->expense_save($value["id"],$eid,$expenselist[$value['id']]);
			}else{
				$this->elder_m->expense_del($value["id"],$eid);
			}
		}
	}

	//检测编号是否冲突
	public function chknum_f()
	{
		$shopid = $this->trans_lib->int("shopid");
		$num = $this->trans_lib->safe("num");
		if(!$shopid){
			exit("未指分院");
		}
		if(!$num){
			exit("未指定编号");
		}
		$rs = $this->elder_m->chk_num($num,$shopid);
		if($rs){
			exit("ok:".$rs['cn_fullname'].":".$rs['bed_number'].":".$rs['note']);
		}
		exit("老人信息不存在");
	}

	//检测编号是否冲突
	public function chknum2_f()
	{
		$shopid = $this->trans_lib->int("shopid");
		$num = $this->trans_lib->safe("num");
		if(!$shopid){
			exit("未指分院");
		}
		if(!$num){
			exit("未指定编号");
		}
		$rs = $this->elder_m->chk_num2($num,$shopid);
		if($rs){
			exit("ok:".$rs['cn_fullname'].":".$rs['num'].":".$rs['note']);
		}
		exit("老人信息不存在");
	}

	public function del_f()
	{
		$id = $this->trans_lib->int('id');
		$expdate = $this->trans_lib->safe('expdate');
		if(!$id || !$expdate){
			exit("error:参数不完整理");
		}
		$this->day_m->delAll($id,$expdate);
		$total = $this->products_m->get_count(0,"");
		$rslist = $this->products_m->get_list(0,"",0,$total);//取得产品列表
		$this->expense_month($id,$expdate,$rslist);
		exit('ok');
	}

	public function month_f()
	{
		$pageurl = $this->url('day,month');
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$shoplist = $this->shop_m->get_all("status='1'");//取得所有分类
		$year = $this->trans_lib->int('year');
		if(!$year){
			$year = date("Y");
		}
		$now = date("Y");
		$year_m = $now-10;
		$yearlist = array();
		for($i=$now;$i>$year_m;$i--){
			$yearlist[] = $i;
		}
		$month = $this->trans_lib->safe('month');
		if(!$month){
			$month = date("m");
		}
		$expmonth = $year.'-'.$month;
		$this->tpl->assign('year',$year);
		$this->tpl->assign('month',$month);
		$this->tpl->assign('expmonth',$expmonth);
		$this->tpl->assign('yearlist',$yearlist);
		$this->tpl->assign('monthlist',array('01','02','03','04','05','06','07','08','09','10','11','12'));
		$condition = "m.month='".$expmonth."'";
		$shopid = $this->trans_lib->int('shopid');
		if(!$admin_rs["if_system"]){
			$tmp_shoplist = array();
			$tmp_shopid = array();
			foreach($shoplist as $key=>$value){
				if($value["admin_name"] && in_array($_SESSION["admin_name"],sys_id_list($value["admin_name"]))){
					$tmp_shoplist[] = $value;
					$tmp_shopid[] = $value["id"];
				}
			}
			if(count($tmp_shoplist)<1){
				error("该管理员没有相关分院权限");
			}
			$shoplist = $tmp_shoplist;
			unset($tmp_shoplist);
			if(!$shopid){
				$condition .= " AND e.shopid IN(".sys_id_string($tmp_shopid).") ";
			}
		}
		if($shopid){
			$condition .= " AND e.shopid='".$shopid."' ";
			$this->tpl->assign('shopid',$shopid);
		}
		$this->tpl->assign("shoplist",$shoplist);
		$keytype = $this->trans_lib->safe("keytype");
		$keywords = $this->trans_lib->safe('keywords');
		if($keytype && $keywords){
			$condition .= " AND ".$keytype."='".$keywords."'";
			$pageurl .= "keytype=".$keytype."&keywords=".rawurlencode($keywords)."&";
			$this->tpl->assign('keytype',$keytype);
			$this->tpl->assign('keywords',$keywords);
		}
		$total = $this->day_m->stat_count($condition);
		if($total){
			$pageid = $this->trans_lib->int(SYS_PAGEID);
			$psize = defined("SYS_PSIZE") ? SYS_PSIZE : 30;
			$rslist = $this->day_m->stat_all($condition,$pageid,$psize);
			$this->tpl->assign('rslist',$rslist);
			$this->page_lib->set_psize($psize);
			$pagelist = $this->page_lib->page($pageurl,$total);
			if($pagelist){
				$this->tpl->assign("pagelist",$pagelist);
			}
		}
		$this->tpl->assign('total',$total);
		$this->tpl->display("day/list.html");
	}

	public function mset_f()
	{
		$id = $this->trans_lib->int("id");
		$month = $this->trans_lib->safe("month");
		if(!$id || !$month){
			error("error:参数不完整理");
		}
		$rs = $this->elder_m->get_one($id);
		if(!$rs){
			error('老人不存在');
		}
		$this->tpl->assign('rs',$rs);
		$expenselist = $this->day_m->expense_all($id,'proid',$month);
		$this->tpl->assign('expenselist',$expenselist);
		$total = $this->products_m->get_count(0,"");
		$rslist = $this->products_m->get_list(0,"",0,$total);//取得产品列表
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->display("day/mset.html");
	}

	public function msetok_f()
	{
		$id = $this->trans_lib->int("id");
		$month = $this->trans_lib->safe("month");
		if(!$id || !$month){
			error("error:参数不完整理");
		}
		$rs = $this->elder_m->get_one($id);
		if(!$rs){
			error('老人不存在');
		}
		$expenselist = $this->day_m->expense_all($id,'proid',$month);
		$total = $this->products_m->get_count(0,"");
		$rslist = $this->products_m->get_list(0,"",0,$total);//取得产品列表
		$keys = $expenselist ? array_keys($expenselist) : array();
		foreach($rslist as $key=>$value){
			$pronum = $this->trans_lib->float("proid_".$value["id"]);
			if($pronum>0.001){
				$this->day_m->expense_save($value['id'],$rs['id'],$pronum,$month);
			}else{
				if($keys && count($keys)>0 && in_array($value["id"],$keys)){
					$this->day_m->expense_del($value["id"],$rs['id'],$month);
				}
			}
		}
		$backurl = $this->url("day,month",'&shopid='.$rs['shopid']);
		error('数据保存成功，请稍候…',$backurl);
	}
}