<?php
/***********************************************************
	Filename: app/admin/control/expense.php
	Note	: 店铺管理
	Version : 3.0
	Author  : qinggan
	Update  : 2010-11-26
***********************************************************/
class expense_c extends Control
{
	function __construct()
	{
		parent::Control();
		$this->load_model("expense");
		$this->load_model("shop");
		$this->load_model("admin");
		$this->load_model("elder");
	}

	function expense_c()
	{
		$this->__construct();
	}


	function index_f()
	{
		sys_popedom("expense1:list","tpl");//查看权限
		$shoplist = $this->shop_m->get_all("status='1'");//取得所有分类
		//判断是否是系统管理员
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		$condition = "s.status=1";
		//$condition = "1=1";
		$pageurl = $this->url("expense");
		$shopid = $this->trans_lib->int("shopid");
		if($shopid)
		{
			$condition .= " AND e.shopid='".$shopid."'";
			$pageurl .= "shopid=".$shopid."&";
		}
		if(!$admin_rs["if_system"])
		{
			$tmp_shoplist = array();
			$tmp_shopid = array();
			foreach($shoplist AS $key=>$value)
			{
				if($value["admin_name"] && in_array($_SESSION["admin_name"],sys_id_list($value["admin_name"])))
				{
					$tmp_shoplist[] = $value;
					$tmp_shopid[] = $value["id"];
				}
			}
			if(count($tmp_shoplist)<1)
			{
				error("该管理员没有相关分院权限");
			}
			$shoplist = $tmp_shoplist;
			unset($tmp_shoplist);
			if(!$shopid)
			{
				$condition .= " AND e.shopid IN(".sys_id_string($tmp_shopid).") ";
			}
		}
		$this->tpl->assign("shoplist",$shoplist);
		//判断时间
		$expense_year = $this->trans_lib->int("expense_year");
		$expense_month = $this->trans_lib->int("expense_month");
		if($expense_year || $expense_month)
		{
			$my_expense_month = $expense_month < 10 ? "0".$expense_month : $expense_month;
			$year_month = $expense_year."/".$my_expense_month;
			$condition .= " AND p.exp_mth_no LIKE '%".$year_month."%' ";
			$pageurl .= "expense_year=".$expense_year."&expense_month=".$expense_month."&";
			$this->tpl->assign("expense_month",$expense_month);
			$this->tpl->assign("expense_year",$expense_year);
			$this->tpl->assign("year_month",$year_month);
		}
		$status = $this->trans_lib->int("status");
		if($status)
		{
			$condition .= " AND p.status='".($status == 1 ? "1" : "0")."' ";
			$pageurl .= "status=".$status."&";
			$this->tpl->assign("status",$status);
		}
		$lifestatus = $this->trans_lib->safe("lifestatus");
		if($lifestatus)
		{
			$condition .= " AND e.lifestatus='".$lifestatus."'";
			$pageurl .= "lifestatus=".rawurlencode($lifestatus)."&";
			$this->tpl->assign("lifestatus",$lifestatus);
		}
		$keytype = $this->trans_lib->safe("keytype");
		$keywords = $this->trans_lib->safe("keywords");
		if($keytype && $keywords)
		{
			$pageurl .= "keytype=".rawurlencode($keytype)."&keywords=".rawurlencode($keywords)."&";
			$condition .= " AND ".$keytype."='".$keywords."' ";
			$this->tpl->assign("keytype",$keytype);
			$this->tpl->assign("keywords",$keywords);
		}
		$pageid = $this->trans_lib->int(SYS_PAGEID);
		$psize = defined("SYS_PSIZE") ? SYS_PSIZE : 30;
		$rslist = $this->expense_m->get_list($condition,$pageid,$psize);
		$total = $this->expense_m->get_count($condition);
		$this->tpl->assign("total",$total);
		$this->page_lib->set_psize($psize);
		$this->page_lib->set_half(3);
		$pagelist = $this->page_lib->page($pageurl,$total);
		$this->tpl->assign("pagelist",$pagelist);
		$this->tpl->assign("rslist",$rslist);
		//授权审核功能
		$this->tpl->assign("popedom_status",sys_popedom("expense1:check"));
		$this->tpl->assign("popedom_print",sys_popedom("expense1:print"));
		//获取年信息
		$tmplist = $this->expense_m->year_group();
		$yearlist = array();
		if($tmplist)
		{
			foreach($tmplist AS $key=>$value)
			{
				$yearlist[] = $value["years"];
			}
		}
		$this->tpl->assign("yearlist",$yearlist);
		$urlext = SYS_SESSION_ID.'='.session_id();
		$this->tpl->assign('urlext',$urlext);
		$this->tpl->display("expense/list.html");
	}

	//删除操作
	function del_f()
	{
		$id = $this->trans_lib->int("id");
		if(!$id)
		{
			exit("error:没有指定ID");
		}
		sys_popedom("expense1:delete","ajax");
		$this->expense_m->del($id);
		exit("ok");
	}

	//删除操作
	function del2_f()
	{
		$id = $this->trans_lib->safe("id");
		if(!$id)
		{
			exit("error:没有指定ID");
		}
		sys_popedom("expense1:delete","ajax");
		$list = explode(",",$id);
		foreach($list as $key=>$value){
			$value = intval($value);
			if(!$value){
				continue;
			}
			$this->expense_m->del($value);
		}
		exit("ok");
	}

	//审核
	function status_f()
	{
		$id = $this->trans_lib->safe("id");
		$status = $this->trans_lib->int("status");
		sys_popedom("expense1:check","ajax");
		if(!$id)
		{
			exit("Error:没有指定ID");
		}
		$idlist = sys_id_list($id);
		if(!$idlist || count($idlist)<1)
		{
			exit("Error:没有指定ID");
		}
		foreach($idlist As $key=>$value)
		{
			$this->expense_m->status(intval($value),$status);
		}
		exit("ok");
	}

	function status_all_f()
	{
		$shopid = $this->trans_lib->int("shopid");
		$status = $this->trans_lib->int("status");
		$ymonth = $this->trans_lib->safe("ymonth");
		sys_popedom("expense1:check","ajax");
		if(!$shopid)
		{
			exit("error:对不起，没有指定分院ID");
		}
		if(!$ymonth)
		{
			exit("error:对不起，没有指定月份！");
		}
		$this->expense_m->status_all($shopid,$ymonth,$status);
		exit("ok");
	}

	//打印明细信息
	function printinfo_f()
	{
		$id = $this->trans_lib->int("id");
		if(!$id)
		{
			exit("获取数据失败！");
		}
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		$this->tpl->assign("id",$id);
		$rs = $this->expense_m->get_one($id);
		if(!$admin_rs["if_system"])
		{
			if($rs["admin_id"] != $_SESSION["admin_id"])
			{
				error("您没有权限操作此表单");
			}
			if(!$rs["status"])
			{
				error("该条未审核信息，不能打印");
			}
		}
		$elder_rs = $this->elder_m->get_one($rs["elder_id"]);
		$rs["e_num"] = $elder_rs["num"];
		$this->tpl->assign("rs",$rs);
		$this->tpl->assign("elder_rs",$elder_rs);
		$rslist = $this->expense_m->get_expense_all($id);
		$this->tpl->assign("rslist",$rslist);
		//取得院长信息
		$shop_rs = $this->shop_m->get_one($elder_rs["shopid"]);
		$this->tpl->assign("shop_rs",$shop_rs);
		$this->tpl->display("print/expinfo.html");
	}

	function printlist_f()
	{
		$admin_rs = $this->admin_m->get_one($_SESSION["admin_id"]);
		$this->tpl->assign("admin_rs",$admin_rs);
		$condition = "1=1";
		$shopid = $this->trans_lib->int("shopid");
		if(!$shopid)
		{
			exit("error");
		}
		$condition .= " AND e.shopid='".$shopid."'";
		$shop_rs = $this->shop_m->get_one($shopid);
		if(!$shop_rs)
		{
			exit("error");
		}
		$this->tpl->assign("shop_rs",$shop_rs);
		//判断时间
		$expense_year = $this->trans_lib->safe("expense_year");
		$expense_month = $this->trans_lib->safe("expense_month");
		if($expense_year || $expense_month)
		{
			$my_expense_month = $expense_month < 10 ? "0".$expense_month : $expense_month;
			$year_month = $expense_year."/".$my_expense_month;
			$condition .= " AND p.exp_mth_no LIKE '%".$year_month."%' ";
			if($expense_year && $expense_month)
			{
				$this->tpl->assign("year_month",$year_month);//本月杂费
				//下个月的租费
				$tmptime = mktime(0, 0, 0, $expense_month+1,25,$expense_year);
				$next_year_month = date("Y/m",$tmptime);
				$this->tpl->assign("next_year_month",$next_year_month);
			}
		}
		$status = $this->trans_lib->int("status");
		if($status)
		{
			$condition .= " AND p.status='".($status == 1 ? "1" : "0")."' ";
		}
		$lifestatus = $this->trans_lib->safe("lifestatus");
		if($lifestatus)
		{
			$condition .= " AND e.lifestatus='".$lifestatus."' ";
		}
		$keytype = $this->trans_lib->safe("keytype");
		$keywords = $this->trans_lib->safe("keywords");
		if($keytype && $keywords)
		{
			$condition .= " AND ".$keytype."='".$keywords."' ";
		}
		$total = $this->expense_m->get_count($condition);
		$rslist = $this->expense_m->get_list($condition,0,$total);
		$this->tpl->assign("rslist",$rslist);
		$tplfile = $this->trans_lib->safe("tplfile");
		$iftotal = $this->trans_lib->safe("iftotal");
		$this->tpl->assign("iftotal",$iftotal);
		$file = $tplfile ? 'print/show_expense_list.html' : 'print/expense_list.html';
		$excel = $this->trans_lib->int('excel');
		if($excel){
			header("Content-type:application/vnd.ms-excel");
			header("Content-Disposition:attachment;filename=".date("Ymd")."-".$_SESSION['admin_id']."-".$iftotal.".xls");
		}
		$this->tpl->display($file);
	}


	function view_f()
	{
		$id = $this->trans_lib->int("id");
		if(!$id)
		{
			error("没有指定ID");
		}
		$this->tpl->assign("id",$id);
		$rs = $this->expense_m->get_one($id);
		$elder_rs = $this->elder_m->get_one($rs["elder_id"]);
		$this->tpl->assign("elder_rs",$elder_rs);
		$this->tpl->assign("rs",$rs);

		$rslist = $this->expense_m->get_expense_all($id);
		$this->tpl->assign("rslist",$rslist);
		$this->tpl->display("expense/view.html");
	}

}
?>