<?php
/***********************************************************
	Filename: app/admin/models/shop.php
	Note	: 每日消费统计
	Version : 3.0
	Author  : qinggan
	Update  : 2010-12-19
***********************************************************/
class day_m extends Model
{
	public function __construct()
	{
		parent::Model();
	}

	public function get_count($condition='')
	{
		$sql  = " SELECT count(d.id) ";
		$sql .= " FROM ".$this->db->prefix."elder_day d ";
		$sql .= " LEFT JOIN ".$this->db->prefix."elder e ON(d.elder_id=e.id) ";
		$sql .= " LEFT JOIN ".$this->db->prefix."shop s ON(e.shopid=s.id) ";
		$sql .= " LEFT JOIN ".$this->db->prefix."products p ON(d.pid=p.id) ";
		$sql .= " WHERE ".$condition." GROUP BY d.elder_id,d.expdate";
		$sql = "SELECT count(*) FROM (".$sql.") groups";
		return $this->db->count($sql);
	}
	
	public function get_all($condition="",$pageid=0,$psize=30)
	{
		if(!$condition){
			return false;
		}
		$psize = intval($psize);
		$offset = $pageid>0 ? ($pageid-1)*$psize : 0;
		$sql  = " SELECT e.*,s.shopname,SUM(p.price*d.qty) total,SUM(d.qty) qty,d.expdate ";
		$sql .= " FROM ".$this->db->prefix."elder_day d ";
		$sql .= " LEFT JOIN ".$this->db->prefix."elder e ON(d.elder_id=e.id) ";
		$sql .= " LEFT JOIN ".$this->db->prefix."shop s ON(e.shopid=s.id) ";
		$sql .= " LEFT JOIN ".$this->db->prefix."products p ON(d.pid=p.id) ";
		$sql .= " WHERE ".$condition." GROUP BY d.elder_id,d.expdate ORDER BY d.expdate DESC,e.bed_number DESC,d.id DESC";
		$sql .= " LIMIT ".$offset.",".$psize;
		return $this->db->get_all($sql);
	}

	public function get_list($elder_id,$date='')
	{
		$sql = "SELECT * FROM ".$this->db->prefix."elder_day WHERE elder_id='".$elder_id."' AND expdate='".$date."'";
		$tmplist = $this->db->get_all($sql);
		if(!$tmplist){
			return false;
		}
		$rslist = array();
		foreach($tmplist as $key=>$value){
			$rslist[$value['pid']] = $value['qty'];
		}
		return $rslist;
	}

	

	//存储数据
	public function save($data,$id=0)
	{
		if($id){
			$this->db->update_array($data,"elder_day",array("id"=>$id));
			return true;
		}else{
			$sql = "SELECT * FROM ".$this->db->prefix."elder_day WHERE pid='".$data['pid']."' AND elder_id='".$data['elder_id']."' AND expdate='".$data['expdate']."'";
			$tmp = $this->db->get_one($sql);
			if($tmp){
				$sql = "UPDATE ".$this->db->prefix."elder_day SET qty='".$data['qty']."' WHERE id='".$tmp['id']."'";
				$this->db->query($sql);
				return $tmp['id'];
			}
			$insert_id = $this->db->insert_array($data,"elder_day");
			return $insert_id;
		}
	}

	public function del($eid,$pid='',$expdate='')
	{
		$sql = "DELETE FROM ".$this->db->prefix."elder_day WHERE pid='".$pid."' AND elder_id='".$eid."' AND expdate='".$expdate."'";
		return $this->db->query($sql);
	}

	public function delAll($eid,$expdate='')
	{
		$sql = "DELETE FROM ".$this->db->prefix."elder_day WHERE elder_id='".$eid."' AND expdate='".$expdate."'";
		return $this->db->query($sql);
	}

	public function eAll($eid,$expdate='')
	{
		$tmp = explode("-",$expdate);
		$emonth = $tmp[0].'-'.$tmp[1];
		$sql = "SELECT SUM(qty) qty,pid FROM ".$this->db->prefix."elder_day WHERE expdate LIKE '".$emonth."%' AND elder_id='".$eid."' GROUP BY pid";
		$tmplist = $this->db->get_all($sql);
		if(!$tmplist){
			return false;
		}
		$rslist = array();
		foreach($tmplist as $key=>$value){
			$rslist[$value['pid']] = $value['qty'];
		}
		return $rslist;
	}

	public function expense_all($eid,$keyid="proid",$expmonth='')
	{
		if(!$eid){
			return false;
		}
		$expmonth = str_replace("/","-",$expmonth);
		$sql = "SELECT e.*,p.title,p.price FROM ".$this->db->prefix."elder_month e LEFT JOIN ".$this->db->prefix."products p ON(e.proid=p.id) WHERE e.eid='".$eid."' AND e.pronum>'0' AND month='".$expmonth."'";
		return $this->db->get_all($sql,$keyid);
	}

	public function expense_list($month='',$eid=0)
	{
		$sql = "SELECT * FROM ".$this->db->prefix."elder_month WHERE month='".$month."'";
		if($eid){
			$sql .= " AND eid='".$eid."'";
		}
		return $this->db->get_all($sql);
	}

	public function expense_del($proid,$eid,$expdate='')
	{
		if(!$proid || !$eid){
			return false;
		}
		$tmp = explode("-",$expdate);
		$month = $tmp[0].'-'.$tmp[1];
		$sql = "DELETE FROM ".$this->db->prefix."elder_month WHERE eid='".$eid."' AND proid='".$proid."' AND month='".$month."'";
		return $this->db->query($sql);
	}

	public function expense_save($proid,$eid,$pronum,$expdate='')
	{
		$tmp = explode("-",$expdate);
		$month = $tmp[0].'-'.$tmp[1];
		$sql = "REPLACE INTO ".$this->db->prefix."elder_month(proid,eid,pronum,month) VALUES('".$proid."','".$eid."','".$pronum."','".$month."')";
		return $this->db->query($sql);
	}

	public function stat_count($condition='')
	{
		$sql  = " SELECT count(e.id) FROM ".$this->db->prefix."elder_month m ";
		$sql .= " LEFT JOIN ".$this->db->prefix."products p ON(m.proid=p.id) ";
		$sql .= " LEFT JOIN ".$this->db->prefix."elder e ON(m.eid=e.id) ";
		$sql .= " LEFT JOIN ".$this->db->prefix."shop s ON(e.shopid=s.id) ";
		if($condition){
			$sql .= " WHERE ".$condition." ";
		}
		$sql .= " GROUP BY m.eid";
		$sql = "SELECT count(*) FROM (".$sql.") groups";
		return $this->db->count($sql);
	}

	public function stat_all($condition='',$pageid=0,$psize=30)
	{
		$psize = intval($psize);
		$offset = $pageid>0 ? ($pageid-1)*$psize : 0;
		$sql  = " SELECT SUM(m.pronum*p.price) total,SUM(m.pronum) qty,e.*,s.shopname FROM ".$this->db->prefix."elder_month m ";
		$sql .= " LEFT JOIN ".$this->db->prefix."products p ON(m.proid=p.id) ";
		$sql .= " LEFT JOIN ".$this->db->prefix."elder e ON(m.eid=e.id) ";
		$sql .= " LEFT JOIN ".$this->db->prefix."shop s ON(e.shopid=s.id) ";
		if($condition){
			$sql .= " WHERE ".$condition." ";
		}
		$sql .= " GROUP BY m.eid ORDER BY e.shopid ASC,e.bed_number+0 ASC,e.id DESC";
		$sql .= " LIMIT ".$offset.",".$psize;
		return $this->db->get_all($sql);
	}
}