<?php
/***********************************************************
	Filename: app/admin/models/expense.php
	Note	: 分院管理功能
	Version : 3.0
	Author  : qinggan
	Update  : 2010-12-19
***********************************************************/
class expense_m extends Model
{
	function __construct()
	{
		parent::Model();
	}

	function expense_m()
	{
		$this->__construct();
	}

	function get_one($id)
	{
		if(!$id)
		{
			return false;
		}
		$sql = "SELECT * FROM ".$this->db->prefix."expense WHERE id='".$id."'";
		$rs = $this->db->get_one($sql);
		if(!$rs)
		{
			return false;
		}
		return $rs;
	}

	//取得列表
	function get_list($condition="",$pageid=0,$psize=30)
	{
		$sql = "SELECT p.*,e.cn_fullname,e.en_fullname,e.num,e.bed_number bed_num,e.lifestatus,s.shopname FROM ".$this->db->prefix."expense p ";
		$sql.= " LEFT JOIN ".$this->db->prefix."elder e ON(p.elder_id=e.id) ";
		$sql.= " LEFT JOIN ".$this->db->prefix."shop s ON(e.shopid=s.id) ";
		if($condition)
		{
			$sql .= " WHERE ".$condition;
		}
		$offset = $pageid>0 ? ($pageid-1)*$psize : 0;
		$sql .= " ORDER BY e.shopid ASC,p.exp_mth_no DESC,e.bed_number+0 ASC,p.addtime DESC,p.id DESC LIMIT ".$offset.",".$psize;
		return $this->db->get_all($sql);
	}

	function get_count($condition="")
	{
		$sql .= "SELECT count(p.id) FROM ".$this->db->prefix."expense p ";
		$sql.= " LEFT JOIN ".$this->db->prefix."elder e ON(p.elder_id=e.id) ";
		$sql.= " LEFT JOIN ".$this->db->prefix."shop s ON(e.shopid=s.id) ";
		if($condition)
		{
			$sql .= " WHERE ".$condition;
		}
		return $this->db->count($sql);
	}

	//存储数据
	function save($data,$id=0)
	{
		if($id)
		{
			$this->db->update_array($data,"expense",array("id"=>$id));
			return true;
		}
		else
		{
			$insert_id = $this->db->insert_array($data,"expense");
			return $insert_id;
		}
	}

	function del($id)
	{
		$sql = "DELETE FROM ".$this->db->prefix."expense WHERE id='".$id."'";
		$this->db->query($sql);
		$sql = "DELETE FROM ".$this->db->prefix."expense_list WHERE eid='".$id."'";
	}

	function status($id,$status=0)
	{
		$sql = "UPDATE ".$this->db->prefix."expense SET status='".$status."' WHERE id='".$id."'";
		return $this->db->query($sql);
	}

	//取得杂费详细
	function get_expense_all($eid,$extid = "")
	{
		if(!$eid)
		{
			return false;
		}
		$sql = "SELECT l.* FROM ".$this->db->prefix."expense_list l LEFT JOIN ".$this->db->prefix."products p ON(l.pid=p.id) WHERE l.eid='".$eid."' ORDER BY p.taxis ASC,l.id ASC";
		return $this->db->get_all($sql,$extid);
	}

	//取得临时杂费详情
	function get_tmp_all($adminid)
	{
		if(!$adminid)
		{
			return false;
		}
		$sql = "SELECT * FROM ".$this->db->prefix."tmp_list WHERE eid='".$adminid."' ORDER BY id ASC";
		return $this->db->get_all($sql);
	}

	//存储杂费表
	function save_exp($data,$id=0,$tbl="expense_list")
	{
		if($id)
		{
			$this->db->update_array($data,$tbl,array("id"=>$id));
			return true;
		}
		else
		{
			$insert_id = $this->db->insert_array($data,$tbl);
			return $insert_id;
		}
	}

	function clear_tmp_exp($id)
	{
		$sql = "DELETE FROM ".$this->db->prefix."tmp_list WHERE eid='".$id."'";
		return $this->db->query($sql);
	}

	function del_exp($id,$eid=0,$tbl="expense_list")
	{
		$sql = "DELETE FROM ".$this->db->prefix.$tbl." WHERE pid='".$id."' AND eid='".$eid."'";
		return $this->db->query($sql);
	}

	//
	function chk_exp($pid,$eid=0,$tbl="expense_list")
	{
		$sql = "SELECT * FROM ".$this->db->prefix.$tbl." WHERE pid='".$pid."' AND eid='".$eid."'";
		return $this->db->get_one($sql);
	}

	function chk_exists($eid,$e_date,$r_date,$id=0)
	{
		if(!$eid || !$e_date || !$r_date)
		{
			return false;
		}
		$sql = "SELECT * FROM ".$this->db->prefix."expense WHERE elder_id='".$eid."' AND exp_mth_no='".$e_date."' AND ret_mth_no='".$r_date."'";
		if($id)
		{
			$sql .= " AND id!='".$id."'";
		}
		return $this->db->get_one($sql);
	}

	//
	function year_group()
	{
		$sql = "SELECT FROM_UNIXTIME(addtime,'%Y') years FROM ".$this->db->prefix."expense GROUP BY FROM_UNIXTIME(addtime,'%Y') ORDER BY FROM_UNIXTIME(addtime,'%Y') DESC";
		return $this->db->get_all($sql);
	}

	function get_total_price($userid,$cateid,$exp_month)
	{
		if(!$userid || !$cateid || !$exp_month)
		{
			return false;
		}
		$sql = "SELECT SUM(l.price * l.qty) FROM ".$this->db->prefix."expense_list l ";
		$sql.= " JOIN ".$this->db->prefix."products p ON(l.pid=p.id) ";
		$sql.= " JOIN ".$this->db->prefix."expense e ON(l.eid=e.id) ";
		$sql.= " WHERE e.elder_id='".$userid."' AND p.cateid='".$cateid."' AND e.exp_mth_no='".$exp_month."'";
		//file_put_contents("data/".$userid.".sql",$sql);
		return $this->db->count($sql);
	}

	//存储批量生成的历史数据
	function save_history($data)
	{
		$insert_id = $this->db->insert_array($data,"expense_history");
		return $insert_id;
	}

	function history_30($condition="")
	{
		$sql = "SELECT h.*,a.name admin_name,s.shopname FROM ".$this->db->prefix."expense_history h ";
		$sql.= " LEFT JOIN ".$this->db->prefix."admin a ON(h.admin_id=a.id) ";
		$sql.= " LEFT JOIN ".$this->db->prefix."shop s ON(h.shopid=s.id) ";
		if($condition)
		{
			$sql .= " WHERE ".$condition;
		}
		$sql.= " ORDER BY h.exp_month DESC,h.id DESC LIMIT 30";
		return $this->db->get_all($sql);
	}

	function status_all($shopid,$ymonth,$status='1')
	{
		if(!$shopid || !$ymonth)
		{
			return false;
		}
		$sql = "UPDATE ".$this->db->prefix."expense e JOIN ".$this->db->prefix."elder o ON(e.elder_id=o.id) SET e.status='".$status."' WHERE o.shopid='".$shopid."' AND e.exp_mth_no='".$ymonth."'";
		//file_put_contents("test.sql",$sql);
		return $this->db->query($sql);
	}

}
?>